-- Default settings
defaultTriggers = {
    "Nadhin",
	"Greater Essence",
	"Major Essence",
	-- Spyhill-Set (medium)
	"Cabedail",
	"Barannir",
	"Astaldo",
	"Ethiram",
	"Nedhranc",
	"Longthol",
	-- Orophin's Watch-Set (medium)
	"Tirithgarab",
	"Vanwaranc",
	"Nelegham",
	"Ecthelaim",
	"Thoronail",
	"Beinail",
	-- Western Shore-Set (light)
	"Gweluranc",
	"Formen Falas",
	"Aelin",
	"Andúnë",
	"Helegdail",
	"Golthol",
	-- Guardian of Watchwood-Set (light)
	"Amarthgarab",
	"Eiliadhranc",
	"Tiriacham",
	"Thorembadanir",
	"Braigmaib",
	"Delendail",
	-- Deeping-rift-Set (heavy)
	"Heronthol",
	"Sardhranc",
	"Asham",
	"Eithelaim",
	"Bragollachnir",
	"Nírdail",
	-- Wall's End-Set (heavy)
	"Aranhar",
	"Godhranc",
	"Amon Beleg",
	"Sermaib",
	"Ramdnir",
	"Tirithdail"
};

defaultBlacklist = {
    "Essence of Power"
};

function SaveSettings()
	--Turbine.Shell.WriteLine("Saving...");
    -- Workaround for Turbine localization bug
    local saveDataTrigger = ExportTable(trigger);
	local saveDataBlacklist = ExportTable(blacklist);
    Turbine.PluginData.Save(Turbine.DataScope.Account, "LootFilter", saveDataTrigger, function()
	--Turbine.Shell.WriteLine("Save complete.");
    end);

	Turbine.PluginData.Save(Turbine.DataScope.Account, "LootFilterBlacklist", saveDataBlacklist, function()
	--Turbine.Shell.WriteLine("Save complete.");
    end);
end

function LoadSettings()
    Turbine.PluginData.Load(Turbine.DataScope.Account, "LootFilter", function(loadedData)
	--Turbine.Shell.WriteLine("Loading...");
        if (loadedData) then
            loadedData = ImportTable(loadedData);
            DeepTableCopy(loadedData, trigger);
			--Turbine.Shell.WriteLine("Load complete.");
		else
			SetDefaultTrigger();
        end
    end);

	Turbine.PluginData.Load(Turbine.DataScope.Account, "LootFilterBlacklist", function(loadedData)
	--Turbine.Shell.WriteLine("Loading...");
        if (loadedData) then
            loadedData = ImportTable(loadedData);
            DeepTableCopy(loadedData, blacklist);
			--Turbine.Shell.WriteLine("Load complete.");
		else
			SetDefaultBlacklist();
        end
    end);
end

function AddTrigger(newtrigger)
	trigger[table.getn(trigger) + 1] = newtrigger;
end

function AddToBlacklist(newBlacklistItem)
	blacklist[table.getn(blacklist) + 1] = newBlacklistItem;
end

function DeleteTrigger(deleteTrigger)
	for i = 1, table.getn(trigger) do
		if trigger[i] == deleteTrigger then
		  return table.remove(trigger, i)
		end
	end
end

function DeleteFromBlacklist(deleteItem)
	for i = 1, table.getn(blacklist) do
		if blacklist[i] == deleteItem then
		  return table.remove(blacklist, i)
		end
	end
end

function SetDefaultTrigger()
	trigger = {};
	DeepTableCopy(defaultTriggers, trigger);
end

function SetDefaultBlacklist()
	blacklist = {};
	DeepTableCopy(defaultBlacklist, blacklist);
end

function ClearTrigger()
	trigger = {};
end

function ClearBlacklist()
	blacklist = {};
end

SetDefaultTrigger();
SetDefaultBlacklist();

Turbine.Plugin.Load = LoadSettings;
Turbine.Plugin.Unload = SaveSettings;
